<template>
  <b-container fluid class="show-user">
    <div v-show="contentLoading">
      <vue-content-loading :rtl="true" :height="20" style="width: 100%;height:100%">
        <rect x="0" y="0" rx="4" ry="4" width="50" height="10" />
      </vue-content-loading>
      <VclTable
        style="width: 100%;height:100%"
        vue-content-loading
        :rtl="true"
        :height="150"
        :rows="5"
        :columns="8"
      />

      <vue-content-loading :height="20" style="width: 100%;height:100%">
        <circle cx="5" cy="15" r="5" />
        <circle cx="15" cy="15" r="5" />
        <circle cx="25" cy="15" r="5" />
        <circle cx="35" cy="15" r="5" />
        <circle cx="45" cy="15" r="5" />
      </vue-content-loading>
    </div>
    <div v-show="!contentLoading">
      <div class="col-12 my-8">
        <b-button class="position-absolute left-0 bottom-0" variant="outline-primary">تعداد کل رزومه ها: {{totalItem}}</b-button>
      </div>
      <b-row class="mb-4 d-flex">
        <b-col v-if="options.search" md="3" class="my-2">
          <label class="label-secondary">جستجو</label>
          <div class="input-icon">
            <b-form-input
              v-model="filter"
              type="search"
              id="filterInput"
              class="form-control"
              placeholder="جستجو ..."
              debounce="500"
            ></b-form-input>
          </div>
        </b-col>

        <b-col md="3" class="my-2">
          <label class="label-secondary">مرتب سازی</label>
          <b-form-group class="mb-0">
            <b-input-group>
              <b-form-select
                id="sortBySelect"
                v-model="sortBy"
                :options="sortOptions"
                class="w-75 sort-i-select"
              ></b-form-select>
              <b-form-select v-model="sortDesc" :disabled="!sortBy" class="w-25 sort-t-select">
                <option :value="true">صعودی</option>
                <option :value="false">نزولی</option>
              </b-form-select>
            </b-input-group>
          </b-form-group>
        </b-col>

        <b-col md="3" class="my-2">
          <label class="label-secondary">وضعیت</label>
          <b-form-group class="mb-0">
            <b-input-group>
              <b-form-select v-model="status" @change="forceUpdate">
                <option value="all">همه</option>
                <option value="Confirmed">تایید شده</option>
                <option value="Pending">در حال بررسی</option>
                <option value="Rejected">رد شده</option>
                <option value="Filling">در حال تکمیل اطلاعات</option>
              </b-form-select>
            </b-input-group>
          </b-form-group>
        </b-col>

        <b-col v-if="options.topSelectPage" md="3" class="my-2 mr-auto">
          <label class="label-secondary">تعداد در هر صفحه</label>
          <b-form-group class="mb-0">
            <b-form-select v-model="perPage" :options="pageOptions"></b-form-select>
          </b-form-group>
        </b-col>

        <b-col v-if="options.topPagination" md="7" class="my-2 mr-auto">
          <div class="overflow-auto float-left">
            <b-pagination
              v-model="currentPage"
              pills
              :total-rows="totalRows"
              :per-page="perPage"
              size="lg"
              class="pr-0"
            ></b-pagination>
          </div>
        </b-col>
      </b-row>
      <b-overlay :show="overlay" rounded="sm" variant="primary" opacity="0.4" blur="2px">
        <b-table
          ref="users"
          stacked="sm"
          show-empty
          empty-text="هیچ چیزی برای نشان دادن وجود ندارد"
          empty-filtered-text="هیچ چیزی مطابق با درخواست شما وجود ندارد"
          :items="updateTable"
          :fields="fields"
          :current-page="currentPage"
          :per-page="perPage"
          :filter="filter"
          :sort-by.sync="sortBy"
          :sort-desc.sync="sortDesc"
          @filtered="onFiltered"
          responsive
          hover
        >
          <template v-slot:cell(id)="row">
            <p class="c_direction">{{ row.index +1 }}</p>
          </template>
          <template v-slot:cell(avatar)="row">
            <a href="javascript:;" class="symbol symbol-50 flex-shrink-0">
              <img :src="host+row.item.avatar" alt />
            </a>
          </template>
          <template v-slot:cell(phone)="row">
            <p class="c_direction">{{ row.item.user.phone}}</p>
          </template>
          <template v-slot:cell(dutyStatus)="row">
            <p class="c_direction">{{ row.item.dutyStatus?row.item.dutyStatus:'-----'}}</p>
          </template>
          <template v-slot:cell(createdAt)="row">
            <p class="c_direction">{{ createdAt(row.item.createdAt) }}</p>
          </template>
          <template v-slot:cell(address_s)="row">
            <p class="c_direction">{{ row.item.state.name+'-'+row.item.city.name}}</p>
          </template>
          <template v-slot:cell(status)="row" v-if="options.settingRow.status">
            <b-badge v-if="row.item.ConfirmationStatus == 'Confirmed'" variant="success" class="statusU">تایید شده</b-badge>

            <b-badge v-if="row.item.ConfirmationStatus == 'Pending'" variant="warning" class="statusU">در حال بررسی</b-badge>

            <b-badge v-if="row.item.ConfirmationStatus == 'Rejected'" variant="danger" class="statusU">رد شده</b-badge>

            <b-badge v-if="row.item.ConfirmationStatus == 'Filling'" variant="secondary" class="statusU">در حال تکمیل اطلاعات</b-badge>
            <b-badge v-if="row.item.ConfirmationStatus == 'Showing'" variant="primary" class="statusU">مشاهده شده</b-badge>
          </template>

          <template v-slot:cell(setting)="row">
            <b-button variant="primary" @click="showResume(row.item)" size="sm">مشاهده ی رزومه</b-button>
          </template>
        </b-table>
      </b-overlay>
      <b-row>
        <b-col v-if="options.buttonSelectPage" md="2" class="my-2 float-right">
          <b-form-group class="mb-0">
            <b-form-select v-model="perPage" :options="pageOptions"></b-form-select>
          </b-form-group>
        </b-col>

        <b-col v-if="options.buttonPagination" md="10" class="my-2 d-flex">
          <div class="overflow-auto mr-auto">
            <b-pagination
              v-model="currentPage"
              pills
              :total-rows="totalRows"
              :per-page="perPage"
              size="lg"
            ></b-pagination>
          </div>
        </b-col>
      </b-row>
    </div>
  </b-container>
</template>

<script>
import gql from "graphql-tag";
import { VueContentLoading, VclTable } from "vue-content-loading";
export default {
  props: ["options"],
  components: { VueContentLoading, VclTable },
  data() {
    return {
      fields: this.options.fields,
      totalRows: 1,
      currentPage: 1,
      perPage: 10,
      pageOptions: [1, 5, 10, 15],
      sortBy: "createdAt",
      sortDesc: true,
      filter: null,
      filterOn: [],
      responsive: true,
      placement: "top",
      localNumPages: 1,
      contentLoading: true,
      isBusy: false,
      status: "all",
      overlay: true,
      error: null,
      totalItem:0,
      host:null,
    };
  },

  computed: {
    sortOptions() {
      // Create an options list from our fields
      return this.fields
        .filter(f => f.sortable)
        .map(f => {
          return { text: f.label, value: f.key };
        });
    }
  },
  async mounted() {
    let Storage = localStorage.getItem("resume_admin");
    this.host = JSON.parse(Storage).host;
    this.contentLoading = false;
  },
  methods: {
    onFiltered(filteredItems) {
      // Trigger pagination to update the number of buttons/pages due to filtering
      this.totalRows = filteredItems.length;
      this.currentPage = 1;
    },

    async updateTable() {
      this.overlay = true;
      let variables = {
        limit: this.perPage,
        page: this.currentPage,
        sortBy: this.sortBy,
        sortDesc: this.sortDesc,
        status: this.status,
        filter: this.filter
      };
      let query = gql`
        ${this.options.gueryOption.query.items}
      `;

      return await this.$apollo
        .query({
          query,
          variables,
          context: { headers: { "x-token": this.$auth.getToken("local") } }
        })
        .then(({ data }) => {
          let result = data[this.options.gueryOption.allresult];
          this.totalItem=result.total;
          let items = result[this.options.gueryOption.data];
          this.totalRows = result.paginate.total;
          this.contentLoading = false;
          this.overlay = false;
          if (items.length > 0) {
            return items;
          } else {
            this.totalRows = 0;
            return [];
          }
        })
        .catch(err => {
          let gqlError = err.graphQLErrors;
          if (gqlError.length > 0) {
            if (err.graphQLErrors[0].extensions.code == "UNAUTHENTICATED") {
              let self = this;
              this.$auth.logout().then(res => {
                self.$router.push("/login");
              });
            }
          }
          this.totalRows = 0;
          this.contentLoading = true;
          this.isBusy = false;
          return [];
        });
    },

    async changeStatus(id, status) {
      this.overlay = true;
      let variables = { id: id, status: status };

      let mutation = gql`
        ${this.options.gueryOption.query.status}
      `;
      await this.$apollo
        .mutate({
          mutation,
          variables,
          context: { headers: { "x-token": this.$auth.getToken("local") } }
        })
        .then(({ data }) => {
          if (data.userStatus.status == "200") {
            this.$refs.users.refresh();
          }
        })
        .catch(err => {
          let gqlError = err.graphQLErrors;
          if (gqlError.length > 0) {
            if (err.graphQLErrors[0].extensions.code == "UNAUTHENTICATED") {
              let self = this;
              this.$auth.logout().then(res => {
                self.$router.push("/login");
              });
            }
          }
        });
    },
    forceUpdate() {
      this.$refs.users.refresh();
    },
    createdAt(timestamp) {
      let date = new Date(parseInt(timestamp));
      return date.toLocaleDateString("fa-IR");
    },
    showResume(item) {
      this.$store.commit('resume/setresume', item);
      this.$router.push('/admin/resume');
    },
  }
};
</script>

<style scoped>
.c_direction {
  direction: ltr;
}
.sort-i-select {
  border-top-left-radius: 0 !important;
  border-bottom-left-radius: 0 !important;
  border-top-right-radius: 5px !important;
  border-bottom-right-radius: 5px !important;
}
.sort-t-select {
  border-top-right-radius: 0 !important;
  border-bottom-right-radius: 0 !important;
  border-top-left-radius: 5px !important;
  border-bottom-left-radius: 5px !important;
}
</style>
<style>
.table > tbody > tr > [data-label]::before {
  float: right !important;
}
.page-item .page-link {
  padding: 11px 15px 11px 15px;
}
</style>
